from vcCommand import *
from vcMatrix import *
from vcHelpers.Robot2 import *
import os.path

app = getApplication()
VCID = "vcid:3ac95fce-b11d-402b-8bb2-1d074db663bd"
LINKS = ['mountplate','Link1','Link2','Link3','Link4','Link5','Link6']
snap_cmd = None

def OnStop():
  global feat, snap_cmd
  if snap_cmd:
    snap_cmd.OnTargetSet = None

def OnStart():
  global feat, snap_cmd
  sm = app.SelectionManager
  feat_sel = sm.getSelection(VC_SELECTION_FEATURE)
  if len(feat_sel) < 1:
    print "No feature selected."
    return
  if len(feat_sel) > 1:
    print "Please select only one feature. And then try again"
    return
  feat = feat_sel[0]
  snap_cmd = app.findCommand('interactiveSnap')
  snap_cmd.OnTargetSet = snapped
  snap_cmd.execute()
  print 'Click on the 3d model to define teaching position (TCP)'

def snapped(cmd):
  global snap_cmd
  original_node = app.CurrentContext.ActiveNode
  snap_cmd = app.findCommand('interactiveSnap')
  snap_cmd.OnTargetSet = None
  if snap_cmd.TargetAvailable:
    pos = snap_cmd.TargetPosition
  else:
    pos = vcVector.new()
  root_uri, scriptname = os.path.split(getCommandPath())
  robot_uri = os.path.join(root_uri,'ghost_cartesian.vcmx')
  robo = app.load(robot_uri)
  mtx = robo.PositionMatrix
  mtx.identity()
  robo.X = pos.X
  robo.Y = pos.Y
  robo.Z = 0 #pos.Z
  robo.PositionMatrix = mtx
  controllers = robo.findBehavioursByType(VC_ROBOTCONTROLLER)
  controller = controllers[0]
  controller.Joints[0].InitialValue = pos.X
  controller.Joints[1].InitialValue = pos.Y
  controller.Joints[2].InitialValue = 0 #pos.Z
  offset = original_node.WorldPositionMatrix * feat.NodePositionMatrix
  robo.update()
  controller.FlangeNode.RootFeature.attach(feat)
  offset2 = controller.FlangeNode.InverseWorldPositionMatrix
  feat.PositionMatrix = offset2 * offset
  feat.rebuild()
  app.render()
  print 'Feature succesfully extracted as a Carteasian robot. You can now teach it in Program tab.'


addState( None )